# Gas-Optimized

## Aggregator Contract

* ### Gas-Optimized Router

  1. For the mainstream marketplaces: openSea, elementEx, looksRare and x2y2, the aggregator contract use constant address to reducing read-storage operation and saving gas.
  2. For different purchase scenarios, a series of methods are provided to call, reducing judgment operations and parameter passing.

* ### Inline assembly code <a href="#id-8455" id="id-8455"></a>

  One of the main advantage of using assembly language in solidity comes to saving gas. So the aggregator contract coding with assembly in some necessary places to optimizing gas.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.element.market/developer/gas-optimized.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
